#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "files.h"

// This function reads the lines of text from
// a file. It returns a pointer to a random line
// of text. On error, a NULL is returned.
char *Random_Line(char *filename)
{
    FILE *my_file;
    char line[MAX_INSULT_LINE];
    char *return_value;
    char *result;
    int line_count = 0;
    int grab_line;

    if (! filename) return NULL;
    my_file = fopen(filename, "r");
    if (! my_file) return NULL;

    // count the lines inthe file
    result = fgets(line, MAX_INSULT_LINE, my_file);
    while (result)
    {
       line_count++;
       result = fgets(line, MAX_INSULT_LINE, my_file);
    }

    if (! line_count) return NULL;

    // pick a random value
    fseek(my_file, 0, SEEK_SET);
    grab_line = rand() % line_count;

    // find the selected line
    line_count = 0;
    while (line_count < grab_line)
    {
        fgets(line, MAX_INSULT_LINE, my_file);
        line_count++;
    }
    fclose(my_file);

    // remove CR and LF
    if ( strchr(line, '\n') )
       strchr(line, '\n')[0] = '\0';
    if ( strchr(line, '\r') )
       strchr(line, '\r')[0] = '\0';
    // return the line we read
    return_value = (char *) calloc( strlen(line) + 1, sizeof(char) );
    if (! return_value) return NULL;
    strcpy(return_value, line);
    return return_value;    
}

